/* the blocks world */

block(X) :- member(X, [1,2,3]). 
fluent(on(X,Y)) :- block(X), block(Y).
fluent(clear(X)) :- block(X).
fluent(ontable(X)) :- block(X).

/* define clear in terms of on */

defined(clear(X), -some(x,block(x),on(x,X))) :- fluent(clear(X)).

/* domain (causal) rules */

causes(on(X,Y), -on(Z,Y)) :- fluent(on(X,Y)), fluent(on(Z,Y)), X\==Z.
causes(on(X,Y), -on(X,Z)) :- fluent(on(X,Y)), fluent(on(X,Z)), Y\==Z.
causes(on(X,Y), -ontable(X)) :- fluent(on(X,Y)).
causes(ontable(X), -on(X,Y)) :-  fluent(on(X,Y)).

/* individual action descriptions */

action(stack(X,Y)) :- block(X), block(Y), X\==Y. 
poss(stack(X,Y),ontable(X)).
poss(stack(X,Y),clear(X)).
poss(stack(X,Y),clear(Y)).
effect(stack(X,Y),true,on(X,Y)).

action(unstack(X,Y)) :- block(X), block(Y), X\==Y.
poss(unstack(X,Y),clear(X)).
poss(unstack(X,Y),on(X,Y)).
effect(unstack(X,Y),true,ontable(X)).

/* move(x,y,z): move x from y to z, provided initially x is on y, and clear,
   and z is clear */

action(move(X,Y,Z)) :- block(X),block(Y),block(Z), X\==Y,X\==Z,Y\==Z.
poss(move(X,Y,Z),on(X,Y)).
poss(move(X,Y,Z),clear(X)).
poss(move(X,Y,Z),clear(Z)).
effect(move(X,Y,Z),true,on(X,Z)).
