/*;;;Railroad meet/pass problem.  trains cannot occupy tracks at the same time.
  from McDermott's PDDL domain library */

train(X) :- X=a;X=b.
track(X) :- X=1;X=2;X=3.

static(connected(X,Y)) :- track(X),track(Y),X\==Y.

fluent(clear(X)) :- track(X).
fluent(at(X,Y)) :- train(X),track(Y).

defined(clear(X), -some(x,train(x),at(x,X))) :- fluent(clear(X)).

/*
causes(clear(X), -at(Y,X)) :- fluent(clear(X)), fluent(at(Y,X)).
causes(at(Y,X), -clear(X)) :- fluent(clear(X)), fluent(at(Y,X)).
*/
causes(at(X,Y), -at(Z,Y)) :- fluent(at(X,Y)), fluent(at(Z,Y)), X\==Z.
causes(at(X,Y), -at(X,Z)) :- fluent(at(X,Y)), fluent(at(X,Z)), Y\==Z.

action(move_train(X,Y,Z)) :- track(Y),track(Z),Y\==Z,train(X).
poss(move_train(X,Y,Z), at(X,Y)).
poss(move_train(X,Y,Z), clear(Z)).
poss(move_train(X,Y,Z), connected(Y,Z)).
effect(move_train(X,Y,Z), true, at(X,Z)).
/*
effect(move_train(X,Y,Z), true, clear(Y)).
*/
