(in-package "UNPOP")

; From Furst & Blum, who got it from ???

(define (domain rocket-domain)
   (:requirements :typing :equality)
   (:types rocket place cargo)
   (:predicates (at ?x - (either rocket cargo) ?p - place)
		(has-fuel ?r - rocket)
		(in ?c - cargo ?r - rocket))

   (:action move
       :parameters (?r - rocket ?from ?to - place)
      :precondition (and (at ?r ?from) (has-fuel ?r) (not (= ?from ?to)))
      :effect (and (not (at ?r ?from))
		   (at ?r ?to)
		   (not (has-fuel ?r))))

   (:action unload
       :parameters (?r - rocket ?p - place ?c - cargo)
       :precondition (and (at ?r ?p) (in ?c ?r))
       :effect (and (not (in ?c ?r))
		    (at ?c ?p)))

   (:action load
       :parameters (?r - rocket ?p - place ?c - cargo)
       :precondition (and (at ?r ?p) (at ?c ?p))
       :effect (and (not (at ?c ?p))
		    (in ?c ?r))))

(define (situation three-locs)
  (:domain rocket-domain)
  (:objects london paris jfk - place
	    zephr demon - rocket
	    c1 c2 c3 c4 c5 c6 c7 c8 c9 c10 - cargo)
  (:init (at c1 london) (at c2 london) (at c3 london) (at c4 london)
	 (at c5 london) (at c6 london) (at c7 london) (at c8 london)
	 (at c9 london) (at c10 london)
	 (has-fuel zephyr) (has-fuel demon)
	 (at zephyr london) (at demon london)))

(define (problem rocket-prob-1)
   (:domain rocket-domain)
   (:situation three-locs)
   (:goal (at c1 paris)))

(define (problem rocket-prob-2)
   (:domain rocket-domain)
   (:situation three-locs)
   (:goal (and (at c1 paris) (at c2 jfk))))

(define (problem rocket-prob-3)
   (:domain rocket-domain)
   (:situation three-locs)
   (:goal (and (at c1 paris) (at c2 jfk) (at c3 paris))))

(define (problem rocket-prob-4)
   (:domain rocket-domain)
   (:situation three-locs)
   (:goal (and (at c1 paris) (at c2 jfk) (at c3 paris) (at c4 jfk))))

(define (problem rocket-prob-5)
   (:domain rocket-domain)
   (:situation three-locs)
   (:goal (and (at c1 paris) (at c2 jfk) (at c3 paris) (at c4 jfk)
	       (at c5 paris))))
