/* from McDermott's PDDL library
(in-package "UNPOP")

; From Furst & Blum, who got it from ???
*/

rocket(X) :- X=r1;X=r2;X=r3.
place(X) :- X=p1;X=p2;X=p3.
cargo(X) :- X=c1;X=c2;X=c3.

fluent(at(X,P)) :- (rocket(X);cargo(X)), place(P).
fluent(has_fuel(X)) :- rocket(X).
fluent(in(X,Y)) :- cargo(X),rocket(Y).

causes(at(X,P),-at(X,P1)) :- fluent(at(X,P)),fluent(at(X,P1)),P\==P1.
causes(in(X,Y),-in(X,Y1)) :- fluent(in(X,Y)),fluent(in(X,Y1)),Y\==Y1.
causes(in(X,Y),-at(X,Z)) :- fluent(in(X,Y)),fluent(at(X,Z)).
causes(at(X,Z),-in(X,Y)) :- fluent(in(X,Y)),fluent(at(X,Z)).

action(move(R,P1,P2)) :- rocket(R),place(P1),place(P2),P1\==P2.
poss(move(R,P1,P2), at(R,P1)).
poss(move(R,P1,P2), has_fuel(R)).
effect(move(R,P1,P2),true,at(R,P2)).
effect(move(R,P1,P2),true,-has_fuel(R)).

action(unload(R,P,C)) :- rocket(R),place(P),cargo(C).
poss(unload(R,P,C),at(R,P)).
poss(unload(R,P,C),in(C,R)).
effect(unload(R,P,C), true, at(C,P)).

action(load(R,P,C)) :- rocket(R),place(P),cargo(C).
poss(load(R,P,C),at(R,P)).
poss(load(R,P,C),-in(C,R)).
poss(load(R,P,C),at(C,P)).
effect(load(R,P,C), true,in(C,R)).

