/* scheduling domain: move(l1,l2), load, and unload */


object(X) :- member(X, [1,2,3,4,5]).

fluent(p(X)) :- object(X).
fluent(l(X)) :- object(X).
fluent(in).

causes(l(X),-l(Y)) :- object(X), object(Y), X\==Y.
causes(p(X),-p(Y)) :- object(X), object(Y), X\==Y.
causes(in & l(X), p(X)) :- object(X).

action(move(X,Y)) :- object(X), object(Y), X\==Y.
poss(move(X,Y), l(X)).
effect(move(X,Y),true,l(Y)).

action(load).
poss(load, -in).
poss(load, p(X)<->l(X)) :- object(X).
effect(load, true, in).

action(unload).
poss(unload,in).
effect(unload, true, -in).

